/* */
#include "cddefines.h"
/* cddefines.h set EXTERN,
 * now unset EXTERN so that everything is defined here */
#ifdef EXTERN
#	undef EXTERN
#endif
#define EXTERN 
/* */
/* some things in cddefines.h */
/* this is the output cloudy will talk to, default is stdout and is set below */
FILE *ioQQQ ;
/* these are options to print error output 
 * requested with print errors command */
FILE* ioPrnErr; 
/* this is declared in cddefines and is used for io
 * saying when subs are entered and return */
FILE *debug_fp ;
/* used for punching map*/
FILE *ioMAP = NULL;
/* following set TRUE with print errors command */
int lgPrnErr;
/* levels within hydrogenic atoms */
const int ipH1s = 0;
const int ipH2s = 1;
const int ipH2p = 2;

/* some levels for he-like species, defined in cddefines.c */

/* level 1 */
const int ipHe1s1S = 0;

/* level 2 */
const int ipHe2s3S = 1;
const int ipHe2s1S = 2;
const int ipHe2p3P0 = 3;
const int ipHe2p3P1 = 4;
const int ipHe2p3P2 = 5;
const int ipHe2p1P = 6;

/* level 3 */
const int ipHe3s3S = 7;
const int ipHe3s1S = 8;
const int ipHe3p3P = 9;
const int ipHe3d3D = 10;
const int ipHe3d1D = 11;
const int ipHe3p1P = 12;

/* level 4 */
const int ipHe4s3S = 13;
const int ipHe4s1S = 14;
const int ipHe4p3P = 15;
const int ipHe4d3D = 16;
const int ipHe4d1D = 17;
const int ipHe4f3F = 18;
const int ipHe4f1F = 19;
const int ipHe4p1P = 20;

/* level 5 */
const int ipHe5s3S = 21;
const int ipHe5s1S = 22;
const int ipHe5p3P = 23;
const int ipHe5d3D = 24;
const int ipHe5d1D = 25;
const int ipHe5f3F = 26;
const int ipHe5f1F = 27;
const int ipHe5g3G = 28;
const int ipHe5g1G = 29;
const int ipHe5p1P = 30;

/* these are array indices for isoelectronic sequences,
 * same as element but used for array addressing to make
 * context totally clear */
const int ipH_LIKE=0;
const int ipHE_LIKE=1;

/* these are array indices for some elements */
const int ipHYDROGEN=0;
const int ipHELIUM=1;
const int ipLITHIUM=2;
const int ipBERYLLIUM=3;
const int ipBORON=4;
const int ipCARBON=5;
const int ipNITROGEN=6;
const int ipOXYGEN=7;
const int ipFLUORINE=8;
const int ipNEON=9;
const int ipSODIUM=10;
const int ipMAGNESIUM=11;
const int ipALUMINIUM=12;
const int ipSILICON=13;
const int ipPHOSPHORUS=14;
const int ipSULPHUR=15;
const int ipCHLORINE=16;
const int ipARGON=17;
const int ipPOTASIUM=18;
const int ipCALCIUM=19;
const int ipSCANDIUM=20;
const int ipTITANIUM=21;
const int ipVANADIUM=22;
const int ipCHROMIUM=23;
const int ipMANGANESE=24;
const int ipIRON=25;
const int ipCOBALT=26;
const int ipNICKEL=27;
const int ipCOPPER=28;
const int ipZINC=29;

/* external ZeroNum used to div by zero 
 * ok here since never changed*/
const double ZeroNum = 0.;

/* nzone is zone counter, incremented in routine cloudy */
long int nzone;

/* the iteration counter, set and incremented in routine cloudy */
long int iteration;

#include "taulines.h"/* this must go here since it defines NTA needed for other lines*/

/* following is true extern in taulines.h */
long nWindLine = NWINDDIM;

/* set number of CO rotation levels to default, 20 as set in taulines.h */
long int nCORotate = NCOROTATE;

/* say that space not allocated yet */
int lgCORotateMalloc = FALSE;

#include "abundances.h"
#include "atom_oi.h"
#include "dynamics.h"
#include "angllum.h"
#include "assertresults.h"
#include "assav.h"
#include "atomcwgt.h"
#include "autoit.h"
#include "badstp.h"
#include "bit32.h"
#include "bndsok.h"
#include "broke.h"
#include "ca2mly.h"
#include "caline.h"
#include "called.h"
#include "cddrive.h"
/* this will be set true when cdInit is called.  The definition is in cdInit.
 * Other routines will check that this is TRUE when they are called, 
 * to verify that cdInit was called first */
int lgcdInitCalled=FALSE;
#include "chargtran.h"
#include "che2sn.h"
#include "chnukt.h"
#include "cionhe.h"
#include "colden.h"
#include "co.h"
#include "colion.h"
#include "collionrate.h"
#include "colmas.h"
#include "con0.h"
#include "converge.h"
#include "continuum.h"
#include "cooling.h"
#include "coolheavy.h"
#include "crsnut.h"
#include "cyclot.h"
#include "d10830.h"
#include "dampon.h"
#include "version.h"
#include "dcala.h"
#include "denpow.h"
#include "destcrt.h"
#include "didz.h"
#include "dlaw.h"
#include "dndt.h"
#include "doppvel.h"
#include "double.h"
#include "dphoht.h"
#include "drmin.h"
#include "drminu.h"
#include "drmnon.h"
#include "drneg.h"
#include "dtmase.h"
#include "dump.h"
#include "edgtcm.h"
#include "egray.h"
#include "embesq.h"
#include "extinc.h"
#include "extramax.h"
#include "fe2cool.h"
#include "fe2neg.h"
#include "nfeii.h"
#include "fe2pmp.h"
#include "fe2tau.h"
#include "fe4cool.h"
#include "fekems.h"
#include "filfac.h"
#include "fluct.h"
#include "frcind.h"
#include "freeon.h"
#include "fston.h"
#include "fudgec.h"
#include "geopp.h"
#include "ghabng.h"
#include "grainvar.h"
#include "h2max.h"
#include "h2ozer.h"
#include "habing.h"
#include "hcaseb.h"
#include "hcolrec.h"
#include "he.h"
#include "heots.h"
#include "nhe1lvl.h"
#include "nhe3lvl.h"
#include "helike.h" 
#include "he1as.h"
#include "he1blt.h"
#include "he1bn.h"
#include "he1cbr.h"
#include "he1crt.h"
#include "he1deltat.h"
#include "he1dmp.h"
#include "he1esc.h"
#include "he1ex.h"
#include "he1ind.h"
#include "he1net.h"
#include "he1nionryd.h"
#include "he1nxt.h"
#include "he1rate.h"
#include "he1rb.h"
#include "he1rsp.h"
#include "he1stat.h"
#include "he1str.h"
#include "he1tau.h"
#include "he3as.h"
#include "he3bn.h"
#include "he3c.h"
#include "he3gams.h"
#include "he3hsv.h"
#include "he3lines.h"
#include "he3lte.h"
#include "he3n.h"
#include "he3pht.h"
#include "he3rate.h"
#include "he3rr.h"
#include "he3tau.h"
#include "heat.h"
#include "heatcool.h"
#include "heatlmax.h"
#include "heavy.h"
#include "heinwd.h"
#include "hemase.h"
#include "heopfr.h"
#include "herec.h"
#include "hevmolec.h"
#include "hextra.h"
#include "hfbnet.h"
#include "hhe1.h"
#include "hionrad.h"
#include "hmi.h"
#include "holod.h"
#include "hsrate.h"
#include "hydrogenic.h"

/* this is set true once space malloced, then never change
 * number of levels again with hydrogenic command, 
 * it is used in gethydro to never set number of levels one set here,
 * also to make sure MALLOC only happens one time  */
int lgHydroMalloc = FALSE;

/* these specify the form of the line redistribution function */
/* partial redistribution with wings */
const int ipPRD = 1;
/* complete redistribution, core only, no wings, Hummer's K2 function */
const int ipCRD = -1;
/* complete redistribution with wings */
const int ipCRDW = 2;

/* indices within recombination coefficient array */
/* ipRecEsc is state specific escape probability*/
const int ipRecEsc = 2;
/* the net escaping, including destruction by background and optical deepth*/
const int ipRecNetEsc = 1;
/* ipRecRad is state specific radiative recombination rate*/
const int ipRecRad = 0;
#include "hydrophocs.h"
#include "hyperfine.h"
#include "input.h"
#include "insanity.h"
#include "intalk.h"
#include "ionfracs.h"
#include "ionrange.h"
#include "ip2gam.h"
#include "ip626.h"
#include "ipfe2.h"
#include "iphe1l.h"
#include "iphmin.h"
#include "ipvfil.h"
#include "iso.h"
#include "itercnt.h"
#include "jmin.h"
#include "kshllenr.h"
#include "level3.h"
#include "linesave.h"
/* these are the definitions of the line save arrays in linesave.h */
LinDstSv *LineDSv=NULL;
LinSv *LineSv=NULL;
#include "mappar.h"
#include "max2pht.h"
#include "mean.h"
#include "mewecoef.h"
#include "mgexc.h"
#include "moldrv.h"
#include "negdrg.h"
#include "neutrn.h"
#include "nhe1.h"
#include "nitexc.h"
#include "noconverge.h"
#include "noexec.h"
#include "nomole.h"
#include "norm.h"
#include "nsbig.h"
#include "numderiv.h"
#include "o3data.h"
#include "o3exc.h"
#include "occ1hi.h"
#include "occmax.h"
#include "optimr.h"
#include "pbowen.h"
#include "pca2ex.h"
#include "peimbt.h"
#include "ph1com.h"
#include "phe1lv.h"
#include "phfit.h"
#include "photrate.h"
#include "phycon.h"
#include "physok.h"
#include "plasnu.h"
#include "plot.h"
#include "plwidth.h"
#include "pmp2s.h"
#include "pop371.h"
/* this is set true when space is allocated for the FeII arrays,
 * once this happens nFeIILevel cannot be changed with the atom feii levels command */
int lgFeIIMalloc=FALSE;
/* */
#include "poplevls.h"
#include "pressure.h"
#include "prhd.h"
#include "printit.h"
#include "pumpfe.h"
#include "punchskip.h"
#include "punch.h"
#include "qs.h"
#include "r1335.h"
#include "r2s3bd.h"
#include "radius.h"
#include "reason.h"
#include "reccno.h"
#include "recoil.h"
#include "recom.h"
#include "resion.h"
#include "rfield.h"
/* set true when malloced, init to false */
int lgRfieldMalloced=FALSE;
#include "opacity.h"
int lgOpacMalloced=FALSE;
#include "rt.h"
#include "secondaries.h"
#include "sii.h"
#include "smbeta.h"
#include "sphere.h"
#include "stimax.h"
#include "stopcalc.h"
#include "strkon.h"
#include "struc.h"
#include "taddlya.h"
#include "tehigh.h"
#include "tenden.h"
#include "testit.h"
#include "the1lo.h"
#include "thermal.h"
#include "thigh.h"
#include "thlo.h"
#include "timed.h"
#include "timefc.h"
#include "timesc.h"
#include "totlum.h"
#include "trace.h"
#include "trovrd.h"
#include "typmatrx.h"
#include "u.h"
#include "uspher.h"
#include "vary.h"
#include "varypar.h"
#define NAMELEN 80
char chOptimFileName[NAMELEN] = "optimal.in";
#include "warngs.h"
#include "warnings.h"
#include "wind.h"
#include "wkhtcl.h"
#include "xry.h"
#include "yield.h"
#include "zonecnt.h"

void cdDefines(void)
{
	long int ipZ,
		nelem;
	/* variables for hydrogen routines */
	/*default nnumber of levels for hydrogen atom */
	for( ipZ=0; ipZ < LIMELM; ++ipZ )
	{
		iso.nHighest[ipHYDROGEN][ipZ] = 15;
		/* >>chng 02 jan 18, increase by one to include 2s, so that all loops will be to < nLevels */
		iso.nLevels[ipHYDROGEN][ipZ] = 16;
		iso.nPrintLevels[ipHYDROGEN][ipZ] = iso.nLevels[ipHYDROGEN][ipZ]-1;
	}
	
	/* total number of He-like levels, hydrogen does not exist, of course */
	iso.nHighest[ipHELIUM][ipHYDROGEN] = 0;
	iso.nLevels[ipHELIUM][ipHYDROGEN] = 0;
	iso.nPrintLevels[ipHELIUM][ipHYDROGEN] = 0;

	/* these are the total number of l levels, including the resolved 2 3P */
	for( ipZ=2; ipZ < LIMELM; ++ipZ )
	{
		/* this goes up through n = 3 */
		iso.nHighest[ipHELIUM][ipZ] = 3;
		iso.nLevels[ipHELIUM][ipZ] = 13;
		iso.nPrintLevels[ipHELIUM][ipZ] = 7;
	}

	/* >>chng 01 may 30, increase default number of levels */
	/* Helium itself has 43, through n=6 */
	/* >>chng 01 dec 31, from 6 to 7 */
	iso.nHighest[ipHELIUM][ipHELIUM] = 7;
	iso.nLevels[ipHELIUM][ipHELIUM] = 57;
	iso.nPrintLevels[ipHELIUM][ipHELIUM] = 43;

	/* carbon, oxygen, and iron are quite abundant - these are through n = 4 */
	iso.nHighest[ipHELIUM][ipCARBON] = 4;
	iso.nLevels[ipHELIUM][ipCARBON] = 21;
	iso.nPrintLevels[ipHELIUM][ipCARBON] = 13;

	iso.nHighest[ipHELIUM][ipOXYGEN] = 4;
	iso.nLevels[ipHELIUM][ipOXYGEN] = 21;
	iso.nPrintLevels[ipHELIUM][ipOXYGEN] = 13;

	iso.nHighest[ipHELIUM][ipIRON] = 4;
	iso.nLevels[ipHELIUM][ipIRON] = 21;
	iso.nPrintLevels[ipHELIUM][ipIRON] = 13;

	/* number of electrons in valence shell that can compton recoil ionize */
	{
		long int nCom[LIMELM] = 
		{
			1 , 2 ,								/* K 1s shell */
			1 , 2 ,								/* L 2s shell */
			1 , 2 , 3 , 4 , 5 , 6 ,				/* L 2p shell */
			1 , 2 ,								/* M 3s shell */
			1 , 2 , 3 , 4 , 5 , 6 ,				/* M 3p shell */
			1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 ,		/* M 3d shell */
			1 , 2 ,								/* N 4s shell */
			1 , 2								/* N 4p shell */
		};

		for( nelem=0; nelem<LIMELM; ++nelem )
		{
			recoil.nCompRecoilElec[nelem] = nCom[nelem];
		}
	}
}

#undef EXTERN
#define EXTERN extern
