/* ionfracs.h */
/*
 * args are atomic number, ionization stage
 *
 * second index is ionization stage, 
 * 1 for atom, 2 for first ion
 * 0 is total abundance all species
 *
 * first index is atomic number minus 1, so H is 0
 *
 * xIonFracs[nelem1][0] is gas phase density of element nelem (cm^-3),
 * it includes elements in molecules but not grains
 * xIonFracs[nelem][i] is density of ith ionization stage (cm^-3),
 * [nelem][1] is atom, [][2]) the first ion
 * nelem = 0 for H, 1 for he, etc
 *
 * with this scheme, 
 * OIII is [ipOXYGEN][3]
 * HII is [ipHYDROGEN][2]
 *
 */
EXTERN float xIonFracs[LIMELM+2][LIMELM+2];
/* definitions are in zero.c */

/* >>chng 01 dec 07, add array of some of gas phase elements locked in molecular abundances */
EXTERN float xMolFracs[LIMELM];

